<?php
if (isset($_SERVER['HTTP_HOST']) && ($_SERVER['HTTP_HOST'] != 'localhost') && ($_SERVER['HTTP_HOST'] != '127.0.0.1')) {
	include(dirname(__FILE__) . '/erreurs.php'); //gestion des erreurs PHP sauf en local
}

//donnes pour l'envoi d'un mail
define('EMAIL_MASTER', $_SERVER['SERVER_ADMIN']); //Mail du webmaster
define('EMAIL_MASTER_NAME', 'Webmaster de ' . $_SERVER['HTTP_HOST']); //Nom de l'administrateur

//Chemin depuis la racine
define('CHEMIN_RACINE', '/');

//paramtres limites pour la gestion des exclusions
define('LIMITE_404', 100); // 100 chargement de page par minute maximum
define('LIMITE_401', 3); // 3 erreurs de mot de passe maximum

//donnes pour la connexion  la base de donnes
$db_server = 'votre-serveur-bdd.fr'; //adresse du serveur MySQL ou localhost
$db_name = 'nom_bdd'; //nom de la base de donnes
$db_user_login = 'user_bdd'; //nom d'utilisateur pour la BD
$db_user_pass = 'mot_pass_bdd'; //mot de passe pour la BD

// variable de connection  la BDD
$lk = false;

// supprime les / si les magic quotes sont activs : utilise  la place mysql_real_escape_string
if (get_magic_quotes_gpc()) {
	function noEscape($string) {
		$string = is_array ($string)? array_map ('noEscape', $string): stripslashes ($string);
		return $string;
	}
	$_POST = array_map ('noEscape', $_POST);
	$_GET = array_map ('noEscape', $_GET);
	$_COOKIE = array_map ('noEscape', $_COOKIE);
	$_REQUEST = array_map ('noEscape', $_REQUEST);
}

// fonction de connection a la base de donnes
function my_mysql_select_db() {
	global $lk;
	global $db_server, $db_user_login, $db_user_pass, $db_name;

	if (!$lk) { // verifie si on n'est pas dj connect
		if (($lk = mysql_connect($db_server, $db_user_login, $db_user_pass)) === false) {
			die(mysql_errno() . " : " . mysql_error());
		}
		if (mysql_select_db($db_name, $lk) === false) {
			die(mysql_errno() . " : " . mysql_error());
		}
	}
}

// fonction de lecture de la base de donnes
function my_mysql_query($sql) {
	global $lk;
	
	if (($res = mysql_query($sql, $lk)) === false) {
		die(mysql_errno() . " : " . mysql_error());
	}
	return $res;
}

// fonction de lecture de la base de donnes
function my_mysql_close() {
	global $lk;
	
	if (!mysql_close($lk)) {
		die(mysql_errno() . " : " . mysql_error());
	}
	return $res;
}

// fonction pour protger une chaine
function my_mysql_real_escape_string($chaine) {
	global $lk;

	if (($res = mysql_real_escape_string($chaine, $lk)) === false) {
		die(mysql_errno() . " : " . mysql_error());
	}
	return $res;
}

// contrle qu'une adresse IP ne charge pas trop de pages par minute ou trop de pages interdites
function controle_ip($erreur401 = false) {
	$date_time_array = getdate();
	$hours = $date_time_array['hours'];
	$minutes = $date_time_array['minutes'];
	$seconds = $date_time_array['seconds'];
	$month = $date_time_array['mon'];
	$day = $date_time_array['mday'];
	$year = $date_time_array['year'];
	$date = date('Y/m/d H:i', mktime($hours, $minutes, $seconds, $month, $day-1, $year));
	$date_as = my_mysql_real_escape_string($date);
	$sql_ip = "DELETE FROM ip WHERE date < '$date_as' ";
	$res_ip = my_mysql_query($sql_ip);
	$sql_ip = "DELETE FROM ip_bl WHERE date < '$date_as' ";
	$res_ip = my_mysql_query($sql_ip);

	$domaine = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	$ip_as = my_mysql_real_escape_string($_SERVER['REMOTE_ADDR']);
	$domaine_as = my_mysql_real_escape_string($domaine);
	$date = date('Y/m/d H:i');
	$date_as = my_mysql_real_escape_string($date);
	$ua_as = my_mysql_real_escape_string(empty($_SERVER['HTTP_USER_AGENT'])?'':$_SERVER['HTTP_USER_AGENT']);
	$sql_ip = "SELECT ip FROM ip_bl WHERE ip = '$ip_as' ";
	$res_ip = my_mysql_query($sql_ip);
	if (($res_ip = mysql_fetch_array($res_ip,MYSQL_ASSOC)) !== false) {
		$date_as = my_mysql_real_escape_string($date);
		if ($erreur401) {
			$sql_ip = "UPDATE ip_bl SET cpt_401=cpt_401+1, date='$date_as', ua='	', domaine='$domaine_as' WHERE ip='$ip_as' ";
			$res_ip = my_mysql_query($sql_ip);
		} else {
			$sql_ip = "UPDATE ip_bl SET cpt=cpt+1, date='$date_as', ua='$ua_as', domaine='$domaine_as' WHERE ip='$ip_as' ";
			$res_ip = my_mysql_query($sql_ip);
		}
		header("Status: 403 Forbidden", false, 403);
		die('IP interdite pour abus.');
	}
	$sql_ip = "SELECT * FROM ip WHERE ip = '$ip_as' ";
	$res_ip = my_mysql_query($sql_ip);
	if (($res_ip = mysql_fetch_array($res_ip,MYSQL_ASSOC)) !== false) {
		if ($erreur401) {
			$cpt_401 = $res_ip['cpt_401'] + 1;
			if ($cpt_401 >= LIMITE_401) {
				$cpt = $res_ip['cpt'];
				$cpt_as = my_mysql_real_escape_string($cpt);
				$cpt_401_as = my_mysql_real_escape_string($cpt_401);
				$sql_ip = "INSERT into ip_bl (ua, ip, domaine, date, cpt, cpt_401) values ('$ua_as', '$ip_as', '$domaine_as', '$date_as', '$cpt_as', '$cpt_401_as')";
				$res_ip = my_mysql_query($sql_ip);
				//creation des messages
				$message_erreur = '<font color="#ff0000">';
				$message_erreur .= 'IP bannie car ' . LIMITE_401 . ' erreurs de mot de passe : ' . $_SERVER['REMOTE_ADDR'] . '</font><br><br>';
				$url_erreur_complete = get_complete_url();
				$message_erreur .= 'Voici l\'url source : <a href="' . htmlspecialchars($url_erreur_complete) . '">' . $url_erreur_complete . '</a><br><br>';
				if (isset($_SERVER['HTTP_REFERER'])) {
					$message_erreur .= 'Voici la page d\'origine : <a href="' . htmlspecialchars($_SERVER['HTTP_REFERER']) . '">' . $_SERVER['HTTP_REFERER'] . '</a><br><br>';
				}
				if (isset($_SERVER['HTTP_USER_AGENT'])) {
					$message_erreur .= 'Navigateur : ' . $_SERVER['HTTP_USER_AGENT'] . '<br><br>';
				}
				$message_erreur .= 'Nom de domaine : ' . $domaine . '<br><br>';
				$message_erreur .= '<a href="http://' . $_SERVER['HTTP_HOST'] . CHEMIN_RACINE . 'admin/ip_bloque.php?ip=' . urlencode($_SERVER['REMOTE_ADDR']) . '">Dbloquer</a><br><br>';
				//envoi du message eu webmaster pour le prevenir de l'erreur
				send_mail('IP bannie', $message_erreur);
				header('Status: 403 Forbidden', false, 403);
				die('IP interdite pour abus.');
			} else {
				$sql_ip = "UPDATE ip SET cpt_401=cpt_401+1, date='$date_as', ua='$ua_as', domaine='$domaine_as' WHERE ip='$ip_as' ";
				$res_ip = my_mysql_query($sql_ip);
			}
		} elseif ($res_ip['date'] == $date) {
			$cpt = $res_ip['cpt'] + 1;
			if ($cpt >= LIMITE_404) {
				$cpt_401 = $res_ip['cpt_401'];
				$cpt_as = my_mysql_real_escape_string($cpt);
				$cpt_401_as = my_mysql_real_escape_string($cpt_401);
				$sql_ip = "INSERT into ip_bl (ua, ip, domaine, date, cpt, cpt_401) values ('$ua_as', '$ip_as', '$domaine_as', '$date_as', '$cpt_as', '$cpt_401_as')";
				$res_ip = my_mysql_query($sql_ip);
				//creation des messages
				$message_erreur = '<font color="#ff0000">';
				$message_erreur .= 'IP bannie car plus de ' . LIMITE_404 . ' requtes en 1 minute : ' . $_SERVER['REMOTE_ADDR'] . "</font><br><br>";
				$url_erreur_complete = get_complete_url();
				$message_erreur .= 'Voici l\'url source : <a href="' . htmlspecialchars($url_erreur_complete) . '">' . $url_erreur_complete . '</a><br><br>';
				if (isset($_SERVER['HTTP_REFERER'])) {
					$message_erreur .= 'Voici la page d\'origine : <a href="' . $_SERVER['HTTP_REFERER'] . '">' . $_SERVER['HTTP_REFERER'] . '</a><br><br>';
				}
				if (isset($_SERVER['HTTP_USER_AGENT'])) {
					$message_erreur .= 'Navigateur : ' . $_SERVER['HTTP_USER_AGENT'] . '<br><br>';
				}
				$message_erreur .= 'Nom de domaine : ' . $domaine . '<br><br>';
				$message_erreur .= '<a href="http://' . $_SERVER['HTTP_HOST'] .  CHEMIN_RACINE . 'admin/ip_bloque.php?ip=' . urlencode($_SERVER['REMOTE_ADDR']) . '">Dbloquer</a><br><br>';
				send_mail('IP bannie', $message_erreur);
				header('Status: 403 Forbidden', false, 403);
				die('IP interdite pour abus.');
			} else {
				$sql_ip = "UPDATE ip SET cpt=cpt+1, date='$date_as', ua='$ua_as', domaine='$domaine_as' WHERE ip='$ip_as' ";
				$res_ip = my_mysql_query($sql_ip);
			}
		} else {
			$sql_ip = "UPDATE ip SET cpt=1, date='$date_as', ua='$ua_as', domaine='$domaine_as' WHERE ip='$ip_as' ";
			$res_ip = my_mysql_query($sql_ip);
		}
	} else {
		if ($erreur401) {
			$cpt = 0;
			$cpt_401 = 1;
		} else {
			$cpt = 1;
			$cpt_401 = 0;
		}
		$cpt_as = my_mysql_real_escape_string($cpt);
		$cpt_401_as = my_mysql_real_escape_string($cpt_401);
		$sql_ip = "INSERT into ip (ua, ip, domaine, date, cpt, cpt_401) values ('$ua_as', '$ip_as', '$domaine_as', '$date_as', '$cpt_as', '$cpt_401_as')";
		$res_ip = my_mysql_query($sql_ip);
	}
}


// recherche si une solution n'est pas enregistre pour une erreur 404 sinon envoi un mail
function url_erreur() {
	$url_erreur_complete = get_complete_url();
	$url_erreur_texte = '<a href="' . htmlspecialchars($url_erreur_complete) . '">' . $url_erreur_complete . '</a>';
	if (!check_url_erreur($url_erreur_complete)) {
		$url_erreur = str_replace(CHEMIN_RACINE, '', $_SERVER['REQUEST_URI']); 
		$url_serveur = 'http://' . $_SERVER['HTTP_HOST'] . CHEMIN_RACINE; 
		if (!check_url_erreur($url_erreur)) {
			$date_dernier_acces = date('Y-m-d H:i:s');
			$tabFile = SearchFile($_SERVER['DOCUMENT_ROOT'], '', basename(get_complete_url(true)));
			if (count($tabFile) == 1) {
				$url_redirection = $tabFile[0];
			} else {
				$url_redirection = $url_erreur;
			}
			$add_erreur = 'http://' . $_SERVER['HTTP_HOST'] . CHEMIN_RACINE . 'admin/url_erreur.php?url_serveur=' . urlencode($url_serveur) . '&url_erreur=' . urlencode($url_erreur) . '&url_redirection=' . urlencode($url_redirection) . '&type=301&date_dernier_acces=' . urlencode($date_dernier_acces);
			$sujet='ERREUR 404';
			$message = '<br>Une erreur 404 s\'est produite sur le site.<br><br>';
			if (isset($_SERVER['HTTP_REFERER'])) {
				$message .= 'Provenance : <a href="' . htmlspecialchars($_SERVER['HTTP_REFERER']) . '">' . $_SERVER['HTTP_REFERER'] . '</a><br>';
			}
			$message ='<br>Page : ' . $url_erreur_texte;
			if (isset($_SERVER['HTTP_USER_AGENT'])) {
				$message .= '<br>Navigateur : ' . $_SERVER['HTTP_USER_AGENT'] . '<br>';
			}
			$message .= 'Adresse IP : ' . $_SERVER['REMOTE_ADDR'] . '<br>';
			$message .= 'Nom de domaine : ' . gethostbyaddr($_SERVER['REMOTE_ADDR']) . '<br><br>';
			$message .= '<a href="' . htmlspecialchars($add_erreur) . '">Ajouter une redirection 301 ou 302</a><br>';
			$add_erreur = 'http://' . $_SERVER['HTTP_HOST'] . CHEMIN_RACINE . 'admin/url_erreur.php?url_serveur=' . urlencode($url_serveur) . '&url_erreur=' . urlencode($url_erreur) . '&url_redirection=' . urlencode($url_redirection) . '&type=403&submit=&date_dernier_acces=' . urlencode($date_dernier_acces);
			$message .= '<a href="' . $add_erreur . '" title="Accs interdit">Interdire l\'accs (403)</a><br>';
			$add_erreur = 'http://' . $_SERVER['HTTP_HOST'] . CHEMIN_RACINE . 'admin/url_erreur.php?url_serveur=' . urlencode($url_serveur) . '&url_erreur=' . urlencode($url_erreur) . '&url_redirection=' . urlencode($url_redirection) . '&type=404&submit=&date_dernier_acces=' . urlencode($date_dernier_acces);
			$message .= '<a href="' . $add_erreur . '" title="Page inexistante">Page inexistante (404)</a><br>';
			$add_erreur = 'http://' . $_SERVER['HTTP_HOST'] . CHEMIN_RACINE . 'admin/url_erreur.php?url_serveur=' . urlencode($url_serveur) . '&url_erreur=' . urlencode($url_erreur) . '&url_redirection=' . urlencode($url_redirection) . '&type=410&submit=&date_dernier_acces=' . urlencode($date_dernier_acces);
			$message .= '<a href="' . $add_erreur . '" title="Page supprime">Page supprime (410)</a><br>';
			foreach ($tabFile as $fichier) {
				$message .= $fichier . '<br>';
			}
			send_mail($sujet, $message);
		}
	}
}

// recherche dans la base de donne une url en erreur
function check_url_erreur($url_erreur) {
	$url_erreur_as = my_mysql_real_escape_string($url_erreur);
	$request = "SELECT url_redirection, type FROM redirection_erreur WHERE url_erreur='$url_erreur_as' ";
	$result = my_mysql_query($request);
	if ($ligne = mysql_fetch_array($result)) {
		$url_redirection = $ligne['url_redirection'];
		if ($ligne['type'] == '301') {
			header('Status: 301 Moved Permanently', false, 301);
			header('Location: ' . $url_redirection);
			exit;
		} elseif ($ligne['type'] == '302') {
			header('Status: 302 Moved Temporarily', false, 302);
			header('Location: ' . $url_redirection);
			exit;
		} elseif ($ligne['type'] == '403') {
			header('Status: 403 Forbidden', false, 403);
			if (file_exists(dirname(__FILE__) . '/erreur403.php')) {
				include(dirname(__FILE__) . '/erreur403.php');
			} else {
				controle_ip(true);
			}
			exit;
		} elseif ($ligne['type'] == '410') {
			header('Status: 410 Gone', false, 410);
			if (file_exists(dirname(__FILE__) . '/erreur410.php')) {
				include(dirname(__FILE__) . '/erreur410.php');
			}
			exit;
		}
		$date_dernier_acces = date('Y-m-d H:i:s');
		$date_dernier_acces_as = my_mysql_real_escape_string($date_dernier_acces);
		$url_erreur_as = my_mysql_real_escape_string($url_erreur);
		$request = "UPDATE redirection_erreur SET date_dernier_acces='$date_dernier_acces_as' WHERE url_erreur='$url_erreur_as' ";
		$result = my_mysql_query($request);
		return true;
	}
	return false;
}

// recherche si le fichier ne se trouve pas ailleurs
function SearchFile($racine, $repertoire, $fichier) {
	$tabFile = array();
	$completeDir = $racine . $repertoire;
	if (is_dir($completeDir)) {
		if ($dh = opendir($completeDir)) {
		        // parcours tous les fichiers et rpertoires courants du rpertoire $repertoire
	                while (($file = readdir($dh)) !== false) {
				if (($file != '.') && ($file != '..')) {
					// nom complet du fichier sinon is_dir ne marche pas (me suis dj fait avoir)
					$completeFile = $completeDir . '/' . $file;
					// lance la rcursivit si et seulement si le fichier en cours est un dossier autoris
					if (is_dir($completeFile)) {
						if ($file == $fichier) {
							$tabFile[] = $repertoire . '/' . $file . '/';
						}
						$tabFile_tmp = SearchFile($racine, $repertoire . '/' . $file, $fichier);
						foreach($tabFile_tmp as $file_tmp) {
							$tabFile[] = $file_tmp;
						}
					} else {
						if ($file == $fichier) {
							$tabFile[] = $repertoire . '/' . $file;
						}
					}
				}
			}
			closedir( $dh );
		}
	}
	return $tabFile;
}

// retourne l'url complte de la page courante (avec ou sans les paramtres)
function get_complete_url($sansparam = false) {
	if ($sansparam) {
		if (isset($_SERVER['SCRIPT_URI'])) {
			return $_SERVER['SCRIPT_URI'];
		} else {
			$uri = explode('?', $_SERVER['REQUEST_URI']);
			return 'http://' . $_SERVER['HTTP_HOST'] . $uri[0];
		}
	} else {
		if (isset($_SERVER['SCRIPT_URL']) && isset($_SERVER['REQUEST_URI']) && isset($_SERVER['SCRIPT_URI'])) {
			return str_replace($_SERVER['SCRIPT_URL'], $_SERVER['REQUEST_URI'], $_SERVER['SCRIPT_URI']);
		} else {
			return 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		}
	}
}

// fonction d'envoi d'un mail HTML
function send_mail($sujet, $corps, $priority=3) {
//envoi un email a un visiteur
	if(strtoupper(substr(PHP_OS,0,3)=='WIN')){
		$eol="\r\n";
		$sol="\n";
	}elseif(strtoupper(substr(PHP_OS,0,3)=='MAC')){
		$eol="\r";
	}else{
		$eol="\n";
	}
	if(!isset($sol)){
		$sol = $eol;
	}
	$Momentn = mktime().'.'.md5(rand(1000,9999));
	$bnd = md5(time()).rand(1000,9999);
	$bndp = md5(time()).rand(1000,9999);
	
	$Textmsg = eregi_replace('<br(.{0,2})>', $eol, $corps);
	$Textmsg = eregi_replace('</p>', $eol, $Textmsg);
	$Textmsg = strip_tags($Textmsg);
	//envoi du mail au webmaster
	$to = EMAIL_MASTER_NAME . '<' . EMAIL_MASTER . '>';
	$from = EMAIL_MASTER_NAME . '<' . EMAIL_MASTER . '>';
	$headers = 'From: '.$from.$eol;
	$headers .= 'Reply-To: '.$from.$eol;
	$headers .= 'Return-Path: '.$from.$eol;
	$headers .= 'X-Priority: '.$priority.$eol;
	$headers .= 'Message-ID: <'.$Momentn.'@PHPMAILSERVER>'.$eol;
	$headers .= 'Date: '.date('r').$eol;
	$headers .= 'Sender-IP: '.$_SERVER['REMOTE_ADDR'].$eol;
	$headers .= 'X-Mailer: PHP v'.phpversion().$eol;  
	$headers .= 'MIME-Version: 1.0'.$eol;
	$headers .= 'Content-Type: multipart/mixed; ' . $eol . '	   boundary="' . $bndp . '"' . $eol.$eol;
	$msg  = "This is a multi-part message in MIME format.".$eol.$eol;
	$msg .= '--' . $bndp.$eol;
	$msg .= 'Content-Type: multipart/alternative; ' . $eol . '	   boundary="' . $bnd . '"' . $eol.$eol;
	$msg .= '--'.$bnd.$eol;
	$msg .= "Content-Type: text/plain; charset=iso-8859-1" . $eol;
	$msg .= "Content-Transfer-Encoding: 8bit" . $eol.$eol;
	$msg .= $Textmsg.$eol;
	$msg .= '--' . $bnd.$eol;
	$msg .= 'Content-Type: text/html; charset=iso-8859-1' . $eol;
	$msg .= 'Content-Transfer-Encoding: 8-bit' . $eol.$eol;
	$msg .= $corps.$eol;
	$msg .= '--'.$bnd.'--'.$eol.$eol;
	$msg .= '--'.$bndp.'--';
	//envoi du mail
	if (($_SERVER['HTTP_HOST'] == '127.0.0.1') || ($_SERVER['HTTP_HOST'] == 'localhost')) {
		echo $msg;
	}
	return @mail($to, $sujet, $msg, $headers);
	//voici la ligne a utiliser pour les sites heberges chez Online.net pour l'envoi des mails
	//pour l'utiliser, il faut enlever les '//' devant les lignes ci-dessous et les mettre devant la ligne ci-dessus !
	//return @email("webmaster",$to,$sujet,$corps);
}

?>