-- --------------------------------------------------------

-- 
-- Structure de la table `ip`
-- 

CREATE TABLE `ip` (
  `id` int(11) NOT NULL auto_increment,
  `ua` char(100) collate latin1_general_ci NOT NULL default '',
  `ip` char(50) collate latin1_general_ci NOT NULL default '',
  `domaine` varchar(100) collate latin1_general_ci NOT NULL,
  `date` char(20) collate latin1_general_ci NOT NULL default '',
  `cpt` int(11) NOT NULL default '0',
  `cpt_401` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`),
  KEY `date` (`date`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `ip_bl`
-- 

CREATE TABLE `ip_bl` (
  `id` int(11) NOT NULL auto_increment,
  `ua` char(100) collate latin1_general_ci NOT NULL default '',
  `ip` char(50) collate latin1_general_ci NOT NULL default '',
  `domaine` varchar(100) collate latin1_general_ci NOT NULL,
  `date` char(20) collate latin1_general_ci NOT NULL default '',
  `cpt` int(11) NOT NULL default '0',
  `cpt_401` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- --------------------------------------------------------

-- 
-- Structure de la table `redirection_erreur`
-- 

CREATE TABLE `redirection_erreur` (
  `url_erreur` varchar(500) collate latin1_general_ci NOT NULL,
  `url_redirection` varchar(500) collate latin1_general_ci NOT NULL,
  `type` enum('301','302','401','403','404','410') collate latin1_general_ci NOT NULL,
  `date_dernier_acces` datetime NOT NULL,
  PRIMARY KEY  (`url_erreur`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
